=== bindings/CMakeLists.txt ===
if(BUILD_PYTHON_INTERFACE)
  add_subdirectory(python)
endif()
