=== debian/changelog ===
ros-iron-proxsuite (0.3.6-1jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Justin Carpentier <justin.carpentier@inria.fr>  Fri, 05 May 2023 17:08:36 -0000
